stages:
  - clone 
  - build
  - deploy

# BASE TEMPLATE
# build:
#   stage: build
#   when: on_success
#   tags:
#     - gerbang-be
#   only:
#     - main
#   image: docker:stable
#   services:
#     - docker:dind
#   script:
#     - docker login -u $CI_DOCKER_USERNAME -p $CI_DOCKER_PASSWORD gitlab.informatika.org:4567
#     - docker build -t gitlab.informatika.org:4567/if3250_2022_05_gerbang/if3250_2022_05_gerbang_be .
#     - docker push gitlab.informatika.org:4567/if3250_2022_05_gerbang/if3250_2022_05_gerbang_be


# build:
#   stage: build
#   when: on_success
#   tags:
#     - gerbang-be
#   only:
#     - main
#   image: docker:stable
#   services:
#     - docker:dind
#   script:
#     - docker login --username=$CI_HEROKU_USER --password=$CI_HEROKU_TOKEN registry.heroku.com
#     - docker build --no-cache -t registry.heroku.com/gerbang-be/web .
#     # - curl https://cli-assets.heroku.com/install.sh | sh
#     # - heroku container:login
#     - docker push registry.heroku.com/gerbang-be/web

# # DEPLOY TO HEROKU 
# deploy:
#   stage: deploy
#   when: on_success
#   only:
#     - main
#   image: curlimages/curl:latest
#   services:
#     - docker:dind
#   script:
#     # - curl https://cli-assets.heroku.com/install.sh | sh
#     - heroku container:release web --app gerbang-be

# CLONE REPOSITORY FROM GITLAB
clone:
  stage: clone
  when: on_success
  tags:
    - gerbang-runner
  only:
    - main
  script:
    - cd ~
    - rm -rf if3250_2022_05_gerbang_be
    - git clone https://kevinkdps:glpat-_Py1DBZg7FU6kgzVPzte@gitlab.informatika.org/if3250_2022_05_gerbang/if3250_2022_05_gerbang_be.git
    - cd if3250_2022_05_gerbang_be

# BUILD AND PUSH TO HEROKU REGISTRY
build:
  stage: build
  when: on_success
  tags:
    - gerbang-runner
  only:
    - main
  image: docker:stable
  services:
    - docker:dind
  script:
    # - echo gerbang | sudo -S groupadd docker
    # - sudo usermod -aG docker $USER
    # - sudo chown root:docker /var/run/docker.sock
    # - sudo chown -R root:docker /var/run/docker
    - sudo docker container stop gerbang-be
    - sudo docker container rm gerbang-be
    - sudo docker image rm gerbang-be/web
    - sudo docker build --no-cache -t gerbang-be/web .

# RUN DOCKER 
deploy:
  stage: deploy
  when: on_success
  tags:
    - gerbang-runner
  only:
    - main
  image: curlimages/curl:latest
  services:
    - docker:dind
  script:
    - sudo docker run -d --name gerbang-be -p 8080:80 gerbang-be/web
